package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        return size() == 0;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        for (Entry current : entries) {
            if (current.getKey().equals(key)) {
                return current.getValue();
            }
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        boolean entryNotAdded = true;
        for (Entry current : entries) {
            if (current.getKey().equals(key)) {
                entryNotAdded = false;
                current.setValue(value);
            }
        }
        if (entryNotAdded) {
            Entry entry = new Entry(key, value);
            entries.add(entry);
        }
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> listOfUsers = new ArrayList<>();
        for (Entry current : entries) {
            listOfUsers.add(current.getKey());
        }
        return listOfUsers;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> listOfCarts = new ArrayList<>();
        for (Entry current : entries) {
            listOfCarts.add(current.getValue());
        }
        return listOfCarts;
    }

    @Override
    public Cart remove(User key) {
        for (Entry current : entries) {
            if (current.getKey().equals(key)) {
                entries.remove(current);
                return current.getValue();
            }
        }
        return null;
    }
}
